<?php
class WDD_cache extends plxPlugin {
	public function __construct($default_lang) {
		# appel du constructeur de la classe plxPlugin (obligatoire)
		parent::__construct($default_lang);

		# limite l'acces a l'ecran d'administration du plugin
		# PROFIL_ADMIN , PROFIL_MANAGER , PROFIL_MODERATOR , PROFIL_EDITOR , PROFIL_WRITER
		$this->setConfigProfil(PROFIL_ADMIN);
		$this->setAdminProfil(PROFIL_ADMIN);
		
		# Declaration d'un hook (existant ou nouveau)
		$this->addHook('IndexBegin','IndexBegin');
		$this->addHook('IndexEnd','IndexEnd');
		$this->addHook('WDD_cache_start','WDD_cache_start');
		$this->addHook('WDD_cache_end','WDD_cache_end');

		
	}

	# HOOKS
	###########################################################
	# Met en cache la page entière 			####################
	# si demandé dans la config et 			#####################
	# si la page n'est pas déjà en cache 	####################
	###########################################################
	public function IndexBegin(){
		if ($this->getParam("cache_all_page")>0 && $this->getParam("desactiver_cache")==0){
			echo '	<?php 
						require_once("'.PLX_PLUGINS.'WDD_cache/cache.php"); 
						$filename=urlencode($_SERVER["REQUEST_URI"]).".html";
						$output=cache_read($filename);
						if ($output!==false){ # si le fichier est en cache, on saute la génération de page
							# On applique la réécriture d\'url si nécessaire
							if($plxMotor->aConf["urlrewriting"]) {
								$output = plxUtils::rel2abs($plxMotor->aConf["racine"], $output);
							}

							# On applique la compression gzip si nécessaire et disponible
							if($plxMotor->aConf["gzip"]) {
								if($encoding=plxUtils::httpEncoding()) {
									header("Content-Encoding: ".$encoding);
									$output = gzencode($output,-1,FORCE_GZIP);
							    }
							}

							# Restitution écran
							echo $output;
							exit;
						}
					?>';
			}
	}
	public function IndexEnd(){
		# n'est éxécuté que si cache obsolète
		if ($this->getParam("cache_all_page")>0 && $this->getParam("desactiver_cache")==0){echo '<?php cache_write($filename,$output,'.$this->getParam('cache_duration').');?>';}
	}
	#################################################################

	public function WDD_cache_start($filename){
		if ($this->getParam("desactiver_cache")==0){
			echo '<?php require_once("'.PLX_PLUGINS.'WDD_cache/cache.php");?>' ;
			echo '<?php if (!$contenu=cache_read("'.$filename.'") ){
							cache_start();
							return true;
						}else{echo $contenu;return false;}
					?>';
		}else{echo '<?php return true; ?>';}
	}
	public function WDD_cache_end($filename){
		if ($this->getParam("desactiver_cache")==0){echo '<?php	echo cache_end("'.$filename.'",'.$this->getParam('cache_duration').');?>';}
	}
} 





/* Pense-bete:
 * Récuperer des parametres du fichier parameters.xml
 *	$this->getParam("<nom du parametre>")
 *	$this-> setParam ("param1", 12345, "numeric")
 *	$this->saveParams()
 *
 *	plxUtils::strCheck($string) : sanitize string
 *
 * 
 * Quelques constantes utiles: 
 * PLX_CORE
 * PLX_ROOT
 * PLX_CHARSET
 * PLX_CONFIG_PATH
 * PLX_PLUGINS
 *
 * Appel de HOOK
 *	eval($plxShow->callHook("ThemeEndHead","param1"))  ou eval($plxShow->callHook("ThemeEndHead",array("param1","param2")))
 *	ou $retour=$plxShow->callHook("ThemeEndHead","param1"));
 */
?>
