<?php
/**
 * @author bronco@warriordudimanche.com
 * @copyright open source 
 * @version 0.1
 * @web warriordudimanche.net
 */
 
function cache_read($fichier){
  //lit le cache
  if (!is_dir('temp/')){mkdir ('temp');return false;}//crée le /temp/ si nécessaire
  if (file_exists('temp/'.$fichier)&&!cache_is_obsolete($fichier)){
    $donnees=file_get_contents('temp/'.$fichier);
    return '<!-- cache version of '.$fichier.' -->'.$donnees; 
  }else{return false;}
}
function cache_write($fichier,$donnees,$duree=0){
  if (!is_dir('temp/')){mkdir ('temp');}//crée le /temp/ si nécessaire
  file_put_contents('temp/'.$fichier,$donnees);
  chmod('temp/'.$fichier,0666);
  if ($duree!=0){$duree=date('U')+(60*$duree);}
  touch('temp/'.$fichier,$duree);
}
function cache_clear(){
  if (!is_dir('temp/')){mkdir ('temp');return false;}//crée le /temp/ si nécessaire
  // vide le cache
  $fs=glob('temp/*');
  foreach ($fs as $file){
    unlink ($file);
  }
}
function cache_is_obsolete($fichier){
  $dat=filemtime('temp/'.$fichier);
  if (!file_exists('temp/'.$fichier)){return true;}
  if ($dat==0){return false;}// unlimited
  if ($dat<date('U')){
    cache_delete($fichier);
    return true;
  }
  return false;
}
function cache_delete($fichier){if (file_exists('temp/'.$fichier)){return unlink ('temp/'.$fichier);}}
function cache_start(){ob_start();}
function cache_end($fichier,$duree){
  // termine la mise en cache
  $donnees=ob_get_clean();
  cache_write($fichier,$donnees,$duree);
  return $donnees;
}

/* 
-------------------------------------------------------------------------------------------------
Comment je l'utilise ? 
-------------------------------------------------------------------------------------------------
 Stocker le résultat d'une portion de code
-------------------------------------------------------------------------------------------------
if (!$contenu=cache_read('nom du fichier')){// pas dans le cache on crée / si existe -> echo et stocke dans var
  cache_start();
    
    // tout le code php etc ici 
    
    
  $contenu=cache_end('nom du fichier',0); // ici durée =0 donc le fichier ne sera jamais obsolète
}
echo $contenu;

-------------------------------------------------------------------------------------------------
 Stocker une variable si pas en cache
-------------------------------------------------------------------------------------------------
if (!$tags=cache_read('tags')){
  $tags=array('fun','wtf','omg');
  cache_write('tags',$tags,0);
}
*/

?>

